Subject: Re: Implementation of "160. Feature Launcher Service Specification" ( Re: Java Developer and Platform Engineer ( Re: Kentyou are hiring! ) ) - status update
From: "Michael H. Siemaszko" <[email-masked]>
To: "Timothy Ward" <[email-masked]>
Cc: Levent Gürgen <[email-masked]>
Date: Sat, 19 Oct 2024 23:05:07 +0000

Hi,

Since my recent email with status update, I've been posting updates via PRs shared - instead of one PR, I've split work into several PRs this week, as OSGi conference is nearing and I wanted Tim to be able to review these new things as they come, instead of everything at once, so they can be merged ASAP, i.e.:

- https://github.com/kentyou/feature-launcher-prototype/pull/26#issuecomment-2409497399

- https://github.com/kentyou/feature-launcher-prototype/pull/26#issuecomment-2417124090

- https://github.com/kentyou/feature-launcher-prototype/pull/27#pullrequestreview-2372854564

- https://github.com/kentyou/feature-launcher-prototype/pull/30#issuecomment-2420792025

- https://github.com/kentyou/feature-launcher-prototype/pull/31#issuecomment-2424248179

Especially in the case of https://github.com/kentyou/feature-launcher-prototype/pull/30 and https://github.com/kentyou/feature-launcher-prototype/pull/31, where I need Tim's clarification / confirmation so work on these can be completed, including adding new test cases / assertions in existing test cases, which can only be done once understanding is clarified with Tim.

Regarding tempo of closing issues - i.e. statement that first several weeks 5+ issues per week were closed, then this "dropped" on work with Feature Launcher Command Line client ( https://github.com/kentyou/feature-launcher-prototype/issues/21 ) last week - this is not really a good measure of progress, because all this depends on how granular issues defined are. Those I entered into issue tracker at the start of working on this project, where after initial technical analysis of 160 specification, priorities were set as per outline of functionalities Tim mentioned are needed for the demo, and all that was delivered by October 5th. In the meantime, i.e. after that outline was provided and work already started and those issues were entered into issue tracker, Tim added the "Add the Command line client" issue ( https://github.com/kentyou/feature-launcher-prototype/issues/21 ) which was not very granular .. so I split it into tasks ( instead of creating separate issue for each ): https://github.com/kentyou/feature-launcher-prototype/issues/21#issue-2531628592 to better visualize work done as part of this. Depending on how specifications are broken down / defined, several month long project could be stated in one sentence, and it would not be really possible to measure progress other than looking at commits made, PRs, discussions on those commits / PRs, changes requested and problems which needed to be solved in the meantime.

Since PRs https://github.com/kentyou/feature-launcher-prototype/pull/30 and https://github.com/kentyou/feature-launcher-prototype/pull/31 are awaiting Tim's review and those will close another 3 issues ( https://github.com/kentyou/feature-launcher-prototype/issues/28, https://github.com/kentyou/feature-launcher-prototype/issues/15 and https://github.com/kentyou/feature-launcher-prototype/issues/16 ) from 7 still opened in issue tracker ( https://github.com/kentyou/feature-launcher-prototype/issues ), in the meantime I can work on the following:

a) one of the remaining 4 issues:

- "Merging Configurations" ( https://github.com/kentyou/feature-launcher-prototype/issues/20 )

- "Merging Bundles" ( https://github.com/kentyou/feature-launcher-prototype/issues/19 )

- "Setting the bundle start levels" ( https://github.com/kentyou/feature-launcher-prototype/issues/14 )

- "Overriding Feature variables" ( https://github.com/kentyou/feature-launcher-prototype/issues/13 )

b) one of the other items not defined in issue tracker but marked as to do:

- other timeout values as defined in "160.8.4.3" - currently only default ( 5000 ) is used for `com.kentyou.featurelauncher.impl.FeatureLauncherConfigurationManager.waitForService(long`;

- implementation for item no. 3 from section 160.4.3.2 of specification ( `com.kentyou.featurelauncher.impl.FrameworkFactoryLocator.findFrameworkFactory()` ); currently items no. 2 and 4 from that section ( 160.4.3.2 ) are implemented - see `com.kentyou.featurelauncher.impl.FrameworkFactoryLocator.locateFrameworkFactory(Feature, List<ArtifactRepository>`

- bundle revisions

c) other items, not related to "160. Feature Launcher Service Specification" - in this case, I need this information from you on Monday (21.10) at the latest, otherwise I will focus on items from (a) or (b) above;

Regards,

--
Michael H. Siemaszko

Ideas Into Software LLC

Telegram: mhsiemaszko

Email: [email-masked]
WWW: https://ideas.into.software/

GitHub: https://github.com/ideas-into-software/

LinkedIn: https://www.linkedin.com/in/mhsiemaszko/
Twitter: https://twitter.com/IntoSoftware/

On 10/12/24 03:08, Michael H. Siemaszko wrote:

Hi,

Next PR is awaiting Tim's review: https://github.com/kentyou/feature-launcher-prototype/pull/26

See comment https://github.com/kentyou/feature-launcher-prototype/pull/26#issuecomment-2408278275 for details, including screencast.

This PR takes care of the "The Feature Launcher Command Line", as defined in section 160.4.2.4 of OSGi compendium specification ( https://github.com/kentyou/feature-launcher-prototype/issues/21 ).

Implementation: com.kentyou.featurelauncher.cli.FeatureLauncherCli

Relevant integration test: com.kentyou.featurelauncher.cli.FeatureLauncherCliTest

This perhaps can also be useful for Tim's OSGi conference demo, as it's a self-contained command-line app at which feature JSONs can be "thrown" and everything else is taken care of underneath.

I will proceed to next items, as defined several days ago by Tim.

Regards,

--
Michael H. Siemaszko

Ideas Into Software LLC

Telegram: mhsiemaszko

Email: [email-masked]
WWW: https://ideas.into.software/

GitHub: https://github.com/ideas-into-software/

LinkedIn: https://www.linkedin.com/in/mhsiemaszko/
Twitter: https://twitter.com/IntoSoftware/

On 10/5/24 05:43, Michael H. Siemaszko wrote:

Hi,

Next PR is awaiting Tim's review: https://github.com/kentyou/feature-launcher-prototype/pull/24

There, I also posted info about most important issues encountered along with questions I have ( https://github.com/kentyou/feature-launcher-prototype/pull/24#issuecomment-2394886107 )

It it issues which caused delay - I wanted to make sure everything you asked me to deliver by October 5th for the demo project is covered ( please see below for more on this ).

This PR takes care of the following:

- Set up for integration testing to work with OSGi environment

- Implementation of 'The Feature Runtime Service', including:
* Install a feature into the running OSGi framework instance based on the supplied feature JSON
* Update a feature in the runtime based on the supplied feature JSON
* Remove an installed feature
* Introspecting the installed Features

Plus: refactoring / fixes / improvements.

It covers the following issues:

- Install a feature into the running OSGi framework instance
https://github.com/kentyou/feature-launcher-prototype/issues/8

- Install a feature into the running OSGi framework instance based on the supplied feature JSON
https://github.com/kentyou/feature-launcher-prototype/issues/9

- Remove an installed feature
https://github.com/kentyou/feature-launcher-prototype/issues/10

- Update a feature in the runtime
https://github.com/kentyou/feature-launcher-prototype/issues/11

- Update a feature in the runtime based on the supplied feature JSON
https://github.com/kentyou/feature-launcher-prototype/issues/12

- Introspecting the installed Features
https://github.com/kentyou/feature-launcher-prototype/issues/18

Relevant integration tests are:
- com.kentyou.featurelauncher.impl.runtime.integration.FeatureRuntimeIntegrationTest
- com.kentyou.featurelauncher.impl.FeatureLauncherImplTest
- com.kentyou.featurelauncher.impl.repository.RemoteArtifactRepositoryImplTest
- com.kentyou.featurelauncher.impl.repository.LocalArtifactRepositoryImplTest

To recall, before I started on September 12th, Tim provided the following outline of functionalities needed for demo project:

- Launching framework
* Launching a framework with a "simple" feature, containing bundles and configurations, with no start levels and no framework selection
* Launching a framework with a feature which selects a framework implementation, with no start levels

- Installing features at runtime
* Installing a "simple" feature, with no start levels
* Installing a second feature with overlapping bundles

- Updating features at runtime
* Simple update showing version changes in some of the bundles

- Removing features
* A simple uninstallation case

Now, everything from this list, except for "version changes", is ready; perhaps that should be the next priority ? I.e. introspecting installed bundles is implemented, but updates do not "bump" versions, so there is no "version changes" visible yet.

Please see my comment on this latest PR ( https://github.com/kentyou/feature-launcher-prototype/pull/24#issuecomment-2394886107 ) for possible list of next items and let me know which should take priority.

Regards,

--
Michael H. Siemaszko

Ideas Into Software LLC

Telegram: mhsiemaszko

Email: [email-masked]
WWW: https://ideas.into.software/

GitHub: https://github.com/ideas-into-software/

LinkedIn: https://www.linkedin.com/in/mhsiemaszko/
Twitter: https://twitter.com/IntoSoftware/

On 10/4/24 05:35, Michael H. Siemaszko wrote:

Hi Tim,

I run into more issues during testing of Feature Runtime Service and most are resolved, but I need to defer pushing new PR until remaining issues are resolved. Hopefully by end of today (4.10) this should be ready to go.

"More" because all other I solved, and these will get solved as well.

I apologize for delay, but I cannot push new PR until these are solved. I will send new update as soon as this is done, by end of today (4.10).

Regards,
--
Michael H. Siemaszko

Ideas Into Software LLC

Telegram: mhsiemaszko

Email: [email-masked]
WWW: https://ideas.into.software/

GitHub: https://github.com/ideas-into-software/

LinkedIn: https://www.linkedin.com/in/mhsiemaszko/
Twitter: https://twitter.com/IntoSoftware/

On 9/27/24 04:28, Michael H. Siemaszko wrote:

Hi,

Next PR is awaiting Tim's review: https://github.com/kentyou/feature-launcher-prototype/pull/23. There, I also posted questions I have ( https://github.com/kentyou/feature-launcher-prototype/pull/23#issuecomment-2378281893 )

Unfortunately, I run into several issues on "finish" for this 2nd round, hence the few hour delay ( i.e. I am sending this summary to you now, instead of by end of Thursday, 26.09 ).

This PR takes care of the following:
- Implementation of 'ArtifactRepository' for remote repository type
- Providing Feature configuration to the system via Configuration Admin Service
- Selecting OSGi framework implementation
- Providing Framework Launch Properties

.. plus refactoring / fixes / improvements.

It covers the following issues:

- https://github.com/kentyou/feature-launcher-prototype/issues/2
- https://github.com/kentyou/feature-launcher-prototype/issues/3
- https://github.com/kentyou/feature-launcher-prototype/issues/6
- https://github.com/kentyou/feature-launcher-prototype/issues/7
- https://github.com/kentyou/feature-launcher-prototype/issues/17

Relevant integration tests are:
- com.kentyou.featurelauncher.impl.FeatureLauncherImplTest
- com.kentyou.featurelauncher.impl.repository.RemoteArtifactRepositoryImplTest
- com.kentyou.featurelauncher.impl.repository.LocalArtifactRepositoryImplTest

I will proceed now to take care of "Feature Runtime Service" related issues, unless you prefer other items should be taken care of.

As previously, let's use PR review ( https://github.com/kentyou/feature-launcher-prototype/pull/23 ) to address these items, including questions and comments.

Regards,

--
Michael H. Siemaszko

Ideas Into Software LLC

Telegram: mhsiemaszko

Email: [email-masked]
WWW: https://ideas.into.software/

GitHub: https://github.com/ideas-into-software/

LinkedIn: https://www.linkedin.com/in/mhsiemaszko/
Twitter: https://twitter.com/IntoSoftware/

On 9/20/24 15:27, Timothy Ward wrote:

Hi Michael,

Thank you for this. I have reviewed the pull request, and other than some minor changes I’ve proposed it looks great.

Your proposed next steps look fine to me. Speak with you on Monday.

Tim

Sent from my iPhone

On 19 Sep 2024, at 22:52, Michael H. Siemaszko <[email-masked]> wrote:

Hi,

First PR is awaiting Tim's review: https://github.com/kentyou/feature-launcher-prototype/pull/22

It takes care of the following:
- Implementation of 'ArtifactRepository' for local repository type
- Launching default framework instance based on the supplied feature with local artifact repository
- Parse JSON representation of Feature definition
- Locate default OSGi framework implementation
- Create OSGi Framework instance
- Install bundles in OSGi framework instance
- Start OSGi framework instance
- Cleanup after failure
- Throw LaunchException if an error occurs creating the framework, or locating and installing any of the feature bundles
- Register Artifact Repository Factory and any necessary module metadata with the Java ServiceLoader API
- Register Feature Launcher Service and any necessary module metadata with the Java ServiceLoader API
- Project skeleton
- Use Maven for build automation

.. plus, stuff like logging, framework / bundle event listeners, shutdown hook, and more.

I.e. it covers issues:
- https://github.com/kentyou/feature-launcher-prototype/issues/1,
- https://github.com/kentyou/feature-launcher-prototype/issues/4
- https://github.com/kentyou/feature-launcher-prototype/issues/5

.. plus non-functional requirements and other one-time tasks required at this stage.

If you wish to run it, relevant integration tests are:
- com.kentyou.featurelauncher.impl.repository.LocalArtifactRepositoryImplTest
- com.kentyou.featurelauncher.impl.FeatureLauncherImplTest

I will proceed now to the following:
- https://github.com/kentyou/feature-launcher-prototype/issues/2
- https://github.com/kentyou/feature-launcher-prototype/issues/6
- https://github.com/kentyou/feature-launcher-prototype/issues/7
- https://github.com/kentyou/feature-launcher-prototype/issues/8

Please let me know if you have any comments and I will defer with questions I have until our Monday meeting.

Regards,

--
Michael H. Siemaszko

Ideas Into Software LLC

Telegram: mhsiemaszko

Email: [email-masked]
WWW: https://ideas.into.software/

GitHub: https://github.com/ideas-into-software/

LinkedIn: https://www.linkedin.com/in/mhsiemaszko/
Twitter: https://twitter.com/IntoSoftware/

On 9/18/24 17:52, Michael H. Siemaszko wrote:

Hi Tim,

Yes, I saw the updates to issues ( https://github.com/kentyou/feature-launcher-prototype/issues/ ) already created, as well as the new issue you added for command line client. I am not working on those yet; I may have some questions once I start working on those.

RE: status update - this moved forward since my most recent update sent on Monday ( 16.09 ) and my goal is to provide first commit some time tomorrow ( 19.09 ), along with new status update. I started officially on Thursday ( 12.09 ), so my goal is to provide new commit containing tested functionalities along with status update each Thursday / once per week at least.

RE: weekly status call - I'd prefer on Mondays, some time in the afternoon hours, if that is OK with you; e.g. any time after 2 PM ?

Regards,

--
Michael H. Siemaszko

Ideas Into Software LLC

Telegram: mhsiemaszko

Email: [email-masked]
WWW: https://ideas.into.software/

GitHub: https://github.com/ideas-into-software/

LinkedIn: https://www.linkedin.com/in/mhsiemaszko/
Twitter: https://twitter.com/IntoSoftware/

On 9/18/24 12:26, Timothy Ward wrote:

Hi Michael,

Hopefully you saw my updates to the issues in the repository - please do get back to me if you have any questions. I would also like to set up a regular weekly status call with you so we can keep track of how things are going. Is there a good time slot for you on a Thursday? If not then a Monday afternoon?

All the best,

Tim

On 16 Sep 2024, at 09:15, Timothy Ward <[email-masked]> wrote:

Hi Michael,

Thank you for this, I’ve looked through the issues and it seems to be fairly comprehensive. I do have a few updates to make based on the final review of the draft which happened last Wednesday. I’ll focus on making those updates today and flagging them in the relevant issues - they’re all fairly minor changes, with the exception of one, which is an addition and I will create the issue for you once there’s a section number.

1) Tim mentions "simple feature" in the outline of specs for the demo project several times ( see below ); please clarify what is understood by "simple" or provide example of such feature definitions, which should be supported;

I agree that this wasn’t properly defined. To me a simple feature is one that contains bundles, configurations and possibly some variables, but definitely no extensions. It will also be relatively small (i.e. the total number of bundles and configurations should be less than 10).

2) Where should I commit code for "demo" project ? I.e. https://github.com/kentyou/feature-launcher-prototype GitHub repository Tim created is for implementation of "160. Feature Launcher Service Specification" - shouldn't "demo" project code be stored in a separate repository ?

I would be happy for this to be in the same repository, and for it to evolve over time into an “examples” section

3) Is 'org.osgi.test.cases.featurelauncher' being worked on / planned ? On 'design/386' branch of 'osgi' repo ( https://github.com/osgi/osgi/tree/design/386 ) I found 'org.osgi.test.cases.feature' but no 'org.osgi.test.cases.featurelauncher' ( not yet ? ) ?

Work has not yet started on this, but it does need to happen. We’re in discussions with Aicas to see if they will write the test suite.

4) Aside from local ( https://github.com/kentyou/feature-launcher-prototype/issues/1 ) and remote ( https://github.com/kentyou/feature-launcher-prototype/issues/2 ) repository implementations provided via 'Artifact Repository Factory' should any other types of artifact repositories be implemented ?

This isn’t needed at this stage, but others may be contributed to the implementation in the future.

All the best,

Tim

On 16 Sep 2024, at 00:34, Michael H. Siemaszko <[email-masked]> wrote:

Hi,

Just a quick update:

- Having analyzed "160. Feature Launcher Service Specification", in the issue tracker section of GitHub repository Tim created I created issue for each functionality identified ( https://github.com/kentyou/feature-launcher-prototype/issues ); if there is anything missing, please let me know;

- I also created project skeleton ( using Maven, as per Tim's request ) and skeleton implementations of interfaces to be implemented and will proceed with actual implementation, starting with the following:
* https://github.com/kentyou/feature-launcher-prototype/issues/1
* https://github.com/kentyou/feature-launcher-prototype/issues/4

- Since, to the best of my knowledge, there is no other implementation of "159. Feature Service Specification" ( https://en.wikipedia.org/wiki/OSGi_Specification_Implementations ) than Apache Felix implementation, I will use version 1.0.2 of this implementation ( https://central.sonatype.com/artifact/org.apache.felix/org.apache.felix.feature/ );

Also, a few questions arose:

1) Tim mentions "simple feature" in the outline of specs for the demo project several times ( see below ); please clarify what is understood by "simple" or provide example of such feature definitions, which should be supported;

2) Where should I commit code for "demo" project ? I.e. https://github.com/kentyou/feature-launcher-prototype GitHub repository Tim created is for implementation of "160. Feature Launcher Service Specification" - shouldn't "demo" project code be stored in a separate repository ?

3) Is 'org.osgi.test.cases.featurelauncher' being worked on / planned ? On 'design/386' branch of 'osgi' repo ( https://github.com/osgi/osgi/tree/design/386 ) I found 'org.osgi.test.cases.feature' but no 'org.osgi.test.cases.featurelauncher' ( not yet ? ) ?

4) Aside from local ( https://github.com/kentyou/feature-launcher-prototype/issues/1 ) and remote ( https://github.com/kentyou/feature-launcher-prototype/issues/2 ) repository implementations provided via 'Artifact Repository Factory' should any other types of artifact repositories be implemented ?

Regards,

--
Michael H. Siemaszko

Ideas Into Software LLC

Telegram: mhsiemaszko

Email: [email-masked]
WWW: https://ideas.into.software/

GitHub: https://github.com/ideas-into-software/

LinkedIn: https://www.linkedin.com/in/mhsiemaszko/
Twitter: https://twitter.com/IntoSoftware/

On 9/9/24 15:57, Timothy Ward wrote:

Hi Michael,

The purpose of the demonstration would be to cover the high-level goals of the specification, specifically:

Launching a framework with:

A “simple” feature in it containing bundles and configurations (no start levels, no framework selection)

A feature which selects a framework implementation (still no start levels)

Installing features at runtime

A “simple” feature (no start levels)

A second feature with overlapping bundles

Updating features at runtime

A simple update showing version changes in some of the bundles

Removing features

A simple uninstallation case

I agree that most (possibly all) of this would be useful input for integration testing - especially as it avoids the more complex areas such as start level processing. We can discuss how best to create the demo content once you get started. I have created a private GitHub repository at https://github.com/kentyou/feature-launcher-prototype and invited you to collaborate there. The current plan is that this repository will become public in the near future, and that the code will likely be contributed to Eclipse in the following months.

Our preference is to use a maven build, but do let us know if that is likely to slow things significantly.

All the best,

Tim

On 9 Sep 2024, at 14:26, Michael H. Siemaszko <[email-masked]> wrote:

Hi Tim,

Thank you for this clarification.

Regarding demonstration: in order to properly test everything, in addition to integration tests, I would prepare a demo project anyway where this is utilized, to verify that everything works. Do you have any specific idea for such demo project - perhaps this ( i.e. demo project ) can be combined / re-used, for the purpose of properly testing this implementation ?

Regarding weekly sync: yes, I would report progress to you anyway, in written form, at least once per week, and we can have a call as well, as you prefer.

Aside from this demo project question, I do not have any other questions at this point, and even this is not a blocker, so looks like we're ready to start.

Levent: please let me know if I should prepare contract then. Provided we finalize with these formalities by tomorrow, I could start tomorrow ( Tuesday, September 10th ) or the day after ( 11.09 ).

Regards,

--
Michael H. Siemaszko

Ideas Into Software LLC

Telegram: mhsiemaszko

Email: [email-masked]
WWW: https://ideas.into.software/

GitHub: https://github.com/ideas-into-software/

LinkedIn: https://www.linkedin.com/in/mhsiemaszko/
Twitter: https://twitter.com/IntoSoftware/

On 9/9/24 12:31, Timothy Ward wrote:

Hi Michael,

Just to confirm, we are looking for an implementation of chapter 160 - the Feature Launcher Service. This could rely on the existing implementation of chapter 159 from Felix (https://github.com/apache/felix-dev/tree/master/features, https://mvnrepository.com/artifact/org.apache.felix/org.apache.felix.feature) or another suitable implementation. The implementation of chapter 160 will be made open source, so all dependencies must be compatible with Eclipse Licensing.

Levent will be dealing with the commercial points, but the timeline requires that we have something that can be demonstrated at the OSGi Summit/OCX in mid October, so ideally we’d have something “working” (not necessarily bug free) by the 7th of October so that we have time to assemble a demonstration with it. If we are able to go ahead then I’m expecting that we’ll have regular (weekly?) chats to update progress, as well as me being available to answer any questions that come up.

All the best,

Tim

On 4 Sep 2024, at 02:20, Michael H. Siemaszko <[email-masked]> wrote:

Hi!

Thank you very much for reaching out. I understand it was August / holiday time, hence the silence after our call several weeks ago. I'm glad I can be of help!

Few questions to start with:

a) Is it "159. Feature Specification" ( page 71 of https://www.eclipse.org/lists/osgi-dev/pdf4su7jtjIaR.pdf ) or "160. Feature Launcher Service Specification" ( page 93 of https://www.eclipse.org/lists/osgi-dev/pdf4su7jtjIaR.pdf ) or both ? You mention "OSGi Feature Specification", then refer to "OSGi Feature Launcher Service Specification", so it is not clear;

b) If this was a long term contract, billing would be monthly, per daily rate; since we do not have a long term contract yet, billing would be weekly, per hourly rate, which is higher than in long term contract - either way, it is time & material; also, that implies a B2B form of contract - is that something you are comfortable with and should I prepare such short term time & material contract then ?

c) You mentioned you want to start ASAP, but how soon you need this done ? I need to know as I have other things going on and could devote 20-32 hours per week, depending on how soon this needs to be done;

I could start early next week, provided we can get formalities taken care of until then.

Kind regards,

--
Michael H. Siemaszko

Ideas Into Software LLC

Telegram: mhsiemaszko

Email: [email-masked]
WWW: https://ideas.into.software/

GitHub: https://github.com/ideas-into-software/

LinkedIn: https://www.linkedin.com/in/mhsiemaszko/
Twitter: https://twitter.com/IntoSoftware/

On Tuesday, September 3rd, 2024 at 10:46 PM, Levent Gürgen <[email-masked]> wrote:

Hi Michael,

Thanks for your email and sorry for my late reply.

We have been discussing internally and we think that we may have an immediate opportunity of collaboration with you under a concrete implementation task.

It is about the implementation of the OSGi Feature Specification

The latest updates and comments for the Feature Launcher specification can be found at https://github.com/osgi/osgi/pull/699

The actual API classes are available at https://github.com/osgi/osgi/tree/design/386/org.osgi.service.featurelauncher

A PDF copy of the specification draft can be found at https://www.eclipse.org/lists/osgi-dev/pdf4su7jtjIaR.pdf

We would ideally like to start as soon as possible.

Would this be something you would be interested in helping us for?

We can discuss about details if you are interested.

All the best,

Levent

De : Michael H. Siemaszko <[email-masked]>
Date : mercredi, 14 août 2024 à 14:29
À : Timothy Ward <[email-masked]>
Cc : Levent Gürgen <[email-masked]>, Thomas CALMANT <[email-masked]>
Objet : Re: Java Developer and Platform Engineer ( Re: Kentyou are hiring! )

Hello,

Thank you for the call yesterday.

If I can be of help, or if you have any additional questions - perhaps on more problem-solving level ( please see https://ideas.into.software/case-studies/ for a lot of such examples, i.e. problems which had to be solved ) - please do not hesitate to get in touch.

Regards,

--

Michael H. Siemaszko

Ideas Into Software LLC

Telegram: mhsiemaszko

Email: [email-masked]

WWW: https://ideas.into.software/

GitHub: https://github.com/ideas-into-software/

LinkedIn: https://www.linkedin.com/in/mhsiemaszko/

Twitter: https://twitter.com/IntoSoftware/

On 8/9/24 10:50, Timothy Ward wrote:

Hi Michael,

I’m glad that time works for you - I’ve send a Teams meeting invite for Tuesday at 1530. We don’t normally use a live coding session for candidates with a GitHub portfolio demonstrating that they can code, so it will be a more general/theoretical interview. There’s no need to prepare a development environment.

I look forward to speaking with you on Tuesday.

All the best,

Tim

On 8 Aug 2024, at 23:37, Michael H. Siemaszko <[email-masked]> wrote:

Hi Tim,

Thank you - I appreciate your interest in working together.

Tuesday ( 13.08 ) at 15:30 CET would work for me.

Should I prepare any specific environment for that meeting - e.g. you require a live coding session ? I am fresh off working for 3 years on a very similar position ( https://kentyou.com/2021/08/20/java-developer/), as you may know, but there are a multitude of technologies this touches upon. So, if possible, please let me know if any up-front environment set up is required / areas you're most interested in.

Regards,

--

Michael H. Siemaszko

Ideas Into Software LLC

Telegram: mhsiemaszko

Email: [email-masked]

WWW: https://ideas.into.software/

GitHub: https://github.com/ideas-into-software/

LinkedIn: https://www.linkedin.com/in/mhsiemaszko/

Twitter: https://twitter.com/IntoSoftware/

On 8/8/24 17:55, Timothy Ward wrote:

Hi Michael,

I’m glad to hear that your first interview went well - the next interview will be more technical, and we should be able to fit it in next week.

Would you be free to meet (virtually) on Tuesday between 1030 and 1200, or 1530 to 1630? If Wednesday would be better then we could also make 1030-1200 then as well.

All the best,

Tim Ward

On 8 Aug 2024, at 15:15, Levent Gürgen <[email-masked]> wrote:

Thanks Michael for the call today and the information you sent.

Tim will contact you to setup another interview for early next week.

All the best,

Levent

De : Michael H. Siemaszko <[email-masked]>
Date : jeudi, 8 août 2024 à 15:39
À : Levent Gürgen <[email-masked]>
Objet : Re: Java Developer and Platform Engineer ( Re: Kentyou are hiring! )

Hi Levent,

Attached please find example of most recent contract, with Data in Motion; as explained, we extended twice, worked together for 3 years.

Regards,

--

Michael H. Siemaszko

Ideas Into Software LLC

Telegram: mhsiemaszko

Email: [email-masked]

WWW: https://ideas.into.software/

GitHub: https://github.com/ideas-into-software/

LinkedIn: https://www.linkedin.com/in/mhsiemaszko/

Twitter: https://twitter.com/IntoSoftware/

On Thursday, August 8th, 2024 at 3:24 PM, Michael H. Siemaszko <[email-masked]> wrote:

Hi Levent,

Thank you for the call today. As agreed, I am attaching testimonial from Juergen Albert / Data in Motion, received after 1st year of working together.

I will follow up with examples of contracts - I need to redact them first / remove some details which I cannot share from them first.

Regards,

--

Michael H. Siemaszko

Ideas Into Software LLC

Telegram: mhsiemaszko

Email: [email-masked]

WWW: https://ideas.into.software/

GitHub: https://github.com/ideas-into-software/

LinkedIn: https://www.linkedin.com/in/mhsiemaszko/

Twitter: https://twitter.com/IntoSoftware/

On Wednesday, August 7th, 2024 at 5:23 PM, Michael H. Siemaszko <[email-masked]> wrote:

Hi Levent,

I confirm our meeting, scheduled for 2 PM CET tomorrow ( 8.08 ).

Thank you and see you tomorrow.

Regards,

--

Michael H. Siemaszko

Ideas Into Software LLC

Telegram: mhsiemaszko

Email: [email-masked]

WWW: https://ideas.into.software/

GitHub: https://github.com/ideas-into-software/

LinkedIn: https://www.linkedin.com/in/mhsiemaszko/

Twitter: https://twitter.com/IntoSoftware/

On Wednesday, August 7th, 2024 at 4:25 PM, Levent Gürgen <[email-masked]> wrote:

Hi Michael,

Thanks. I am sending a calendar invite for tomorrow 8th 2pm then.

You can let me know if it does not work for you.

Thanks and see you tomorrow!

Levent

De : Michael H. Siemaszko <[email-masked]>
Date : mercredi, 7 août 2024 à 15:49
À : Levent Gürgen <[email-masked]>
Cc : Hello Kentyou <[email-masked]>
Objet : Re: Java Developer and Platform Engineer ( Re: Kentyou are hiring! )

Dear Levent,

Thank you very much for your reply. Yes, tomorrow ( 8.08 ) afternoon would suit me. On Friday ( 9.08 ), I'd be available in the afternoon as well.

What time in the afternoon would work for you ? I am available any time starting from 2:00 PM CET until late evening hours.

Regards,

--

Michael H. Siemaszko

Ideas Into Software LLC

Telegram: mhsiemaszko

Email: [email-masked]

WWW: https://ideas.into.software/

GitHub: https://github.com/ideas-into-software/

LinkedIn: https://www.linkedin.com/in/mhsiemaszko/

Twitter: https://twitter.com/IntoSoftware/

On Wednesday, August 7th, 2024 at 10:55 AM, Levent Gürgen <[email-masked]> wrote:

Dear Michael,

Thanks for your interest to our open position.

Would you be available for a quick interview tomorrow afternoon or on Friday late morning?

Best regards,

Levent

Levent Gürgen, PhD

Founder & President

+33 6 32 16 17 01

https://kentyou.com/

De : Michael H. Siemaszko <[email-masked]>
Date : vendredi, 2 août 2024 à 04:21
À : Hello Kentyou <[email-masked]>
Objet : Java Developer and Platform Engineer ( Re: Kentyou are hiring! )

Hello,

This is in regards to "Java Developer and Platform Engineer" position you advertise on https://kentyou.com/2021/08/20/java-developer/.

Attached please find my CV, in both chronological and functional form; also please see https://ideas.into.software/case-studies/ for sample of projects I’ve worked on.

I have extensive experience with OSGi, in addition to matching most of the requirements listed for this position ( https://kentyou.com/2021/08/20/java-developer/ ); for details, please see attached CVs.

If I can be of help, or if you have any questions, please do not hesitate to get in touch.

Regards,

--

Michael H. Siemaszko

Ideas Into Software LLC

Telegram: mhsiemaszko

Email: [email-masked]

WWW: http://ideas.into.software/

GitHub: https://github.com/ideas-into-software/

LinkedIn: http://www.linkedin.com/in/mhsiemaszko/

Twitter: https://twitter.com/IntoSoftware/

On 9/13/23 18:58, Tim Ward wrote:

Hi all,

Are you (or someone you know) looking for a new role? Kentyou are currently looking for experienced Java developers, Full stack engineers and Data Analysts.

Kentyou is a startup company aiming to turn cities into more sustainable, innovative, and citizen-centric environments to live and work in. We do this by enabling simple access to new and existing IoT data sources, as well as through improved data processing, visualisation and Machine Learning tools. We use OSGi technology in our products and in our open source contributions, as well as actively participating in the Eclipse OSGi working group.

If you’re interested then please do get in touch via our website at https://kentyou.com/about-us/join-us/ - we’d love to hear from you!

Best wishes,

Tim Ward

CTO Kentyou